import { sanitizeAlphaFloat } from '../helpers'

const hexToRgb = (hexString) => {
  let hex = 'ffffff'
  if (hexString.length === 3) {
    hex = ''
    hex += hexString.substr(2, 1) + hexString.substr(2, 1)
    hex += hexString.substr(1, 1) + hexString.substr(1, 1)
    hex += hexString.substr(0, 1) + hexString.substr(0, 1)
  } else {
    hex = hexString
  }

  let bigint = Number.parseInt(hex, 16)
  let redNum = (bigint >> 16) & 255
  let greenNum = (bigint >> 8) & 255
  let blueNum = bigint & 255

  return { "red": redNum, "green": greenNum, "blue": blueNum }
}

const hexaToRgba = (hexString) => {
  let hex = 'ffffff'
  let alphaHex = 'ff'
  let alpha = 1

  if (hexString.length === 4) {
    alphaHex = hexString.substr(3, 1) + hexString.substr(3, 1)
    hex = ''
    hex += hexString.substr(2, 1) + hexString.substr(2, 1)
    hex += hexString.substr(1, 1) + hexString.substr(1, 1)
    hex += hexString.substr(0, 1) + hexString.substr(0, 1)
  } else {
    alphaHex = hexString.substr(6, 2)
    hex = hexString.substr(0, 6)
  }

  let rgb = hexToRgb(hex)
  alpha = Number.parseFloat((Number.parseInt(alphaHex, 16) / 255)).toFixed(1)

  return { "red": rgb.red, "green": rgb.green, "blue": rgb.blue, "alpha": alpha }
}

const hexToHsl = (hexString) => {
  console.error('hex to HSL not implemented yet')
}

const hexaToHsla = (hexString) => {
  console.error('hexa to HSLa not implemented yet')
}

export { hexToRgb, hexaToRgba, hexToHsl, hexaToHsla }
